"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ldflex = require("ldflex");

var _ldflexComunica = _interopRequireDefault(require("ldflex-comunica"));

var _context = _interopRequireDefault(require("./context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const factory = new _ldflex.QueryPathFactory({
  context: _context.default
});
/**
 * Starts a query path from the given subject
 */

function node(subject) {
  const queryEngine = new _ldflexComunica.default(subject);
  return factory.create({
    queryEngine
  }, {
    subject
  });
}
/**
 * Starts a query path from the currently logged in user
 */


function user() {
  const webid = {
    then: (resolve, reject) => {
      /* global solid */
      solid.auth.currentSession().then(session => {
        if (!session) throw new Error('Querying failed: no active user');
        return session.webId;
      }).then(resolve, reject);
    }
  };
  return node(webid);
}

const _exports = {
  node,

  get user() {
    return user();
  }

};
var _default = _exports;
exports.default = _default;